'use strict';

var RegistraCategoriaController = angular.module('RegistraCategoriaController', []);

RegistraCategoriaController.controller('RegistraCategoriaCtrl', ['$scope', '$rootScope', 'Categoria', 'CacheApp',
  ($scope, $rootScope, Categoria, CacheApp) => {

      $scope.setCategoria = (categoria) => {
          Categoria.setCategoria(categoria,
              (data) => {
                  $rootScope.$broadcast('atualizaListaCategoria', {});
                  $scope.getListaCategoria();
              });
      }

      $scope.adicionarCategoria = () => {
          $scope.listaCategoria.unshift({
              IdCategoria: 0,
              IdClienteDono: $scope.construcao.IdClienteDono,
              Nome: '',
              Descricao: '',
              Novo: true
          });
      }

      $scope.alterarCategoria = (categoria) => {
          categoria.IdClienteDono = $scope.construcao.IdClienteDono;
          categoria.Novo = true;
      }

      $scope.cancelarCategoria = (categoria) => {
          if (categoria.IdCategoria == 0) {
              var idx = $scope.listaCategoria.indexOf(categoria)
              $scope.listaCategoria.splice(idx, 1);
          }
          else
              categoria.Novo = false;
      }

      $scope.getListaCategoria = () => {
          Categoria.getListaCategoria($scope.construcao.IdClienteDono,
              (data) => {
                  $scope.listaCategoria = data.Instance;
              });
      }

      $scope.excluirCategoria = (categoria) => {
          $scope.msgBoxPergunta(categoria.Nome, 'Confirma exclusão da categoria?'
              , () => {
                  Categoria.delCategoria(categoria.IdCategoria,
                      (data) => {
                          $scope.getListaCategoria();
                          $rootScope.$broadcast('atualizaListaCategoria', {});
                      });
              }
              , () => {
              });
      }

    $('#BoxCategoria').on('shown.bs.modal', function (e) {
        $scope.construcao = CacheApp.getConstrucao();
        if ($scope.construcao)
            $scope.getListaCategoria();

        $('#BoxCategoria').off('show.bs.modal');
    });

  }]);
